#include <iostream>

int main()
{
    std::ios::sync_with_stdio(false);
    int N, Q;
    std::cin >> N >> Q;
    int *A=new int[N+1];
    for(int i=1; i<=N; i++) std::cin >> A[i];
    int L, R, res;
    for(int i=0; i<Q; i++)
    {
        std::cin >> L >> R;
        bool postoji=true;
        for(int j=L+1; j<=R; j++) if(A[j]==0)
        {
            std::cout << "0\n";
            postoji=false;
            break;
        }
        if(postoji) std::cout << "1\n";
    }
    delete[] A;
    return 0;
}